PROBLEM LINKS:DIFFICULTY:Easy PREREQUISITES:Heaps PROBLEM:You're given an online stream of numbers. At any point of time if K numbers have already appeared, you need to find out floor(K/3)^{th} largest number. QUICK EXPLANATION:Maintain two heaps  one min heap for top floor(K/3) numbers and other max heap for all remaining numbers. DETAILED EXPLANATION:We can maintain two different heaps  one min heap for top 1/3^{th} of votes and one max heap for all other votes. Once we have this, we can simulate actual voting itself. The reason is after every vote, at maximum 1 vote moves between the heaps. To understand this, let's say that at some point of time we've x votes in top heap and N  x votes in other heap. If a new vote comes push it in one of the two halves by comparing its value to the lowest value in top heap. Now assume it went in top heap. Number of votes in top heap might be more than floor( (N+1) / 3) now in which case we'd need to transfer some numbers to the other heap. But difference is only of 1 vote as number of votes in top heap <= 1 + floor(N/3) and hence only 1 vote needs to goto bottom heap. That one vote has to be the minimum value of this heap. By similar argument, had the vote gone to bottom heap, again only its topmost value need to be transfered to top heap, if at all. At any query, all we have to do is find out the smallest value from top heap and print it. Complexity of our solution is O(N log N) as we take O(log N) time per query. SETTER'S SOLUTION:Can be found here. TESTER'S SOLUTION:Can be found here. RELATED PROBLEMS:
This question is marked "community wiki".
asked 11 Jul '12, 16:09

Pathetic the setters solution shows wrong answer on submissio? Just how bad things can get for Codechef answered 12 Jul '12, 12:32
What the hell man you dont even test your setter's and tester's solutions...
(12 Jul '12, 12:37)
It's true, they give wrong answer. Maybe, because the test data was changed in the contest.
(12 Jul '12, 12:46)
Hey, your right about the setter's solution getting a "wrong answer". However, I added a little code segment to it and resubmitted to check. I got a correct submission this time. http://www.codechef.com/viewsolution/1180239
(14 Jul '12, 17:01)
4 1 10 1 20 1 8 2
(30 Dec '12, 14:55)

This can also be done with MULTISET STL in C++.. but just you have to careful with iterator.. since iterator is only bidirectional here not random. answered 11 Jul '12, 21:54
If anyone want more info on procedure.. i can elaborate
(11 Jul '12, 21:56)
I did the same , http://www.codechef.com/viewsolution/1149847 :)
(11 Jul '12, 22:15)
yep... same way :)
(11 Jul '12, 22:36)
i tried using multisets but i gives me tle...can u please check http://www.codechef.com/viewsolution/1654148
(29 Dec '12, 00:58)
@sikander_nsit  check out your loops.. and check my solution.. there is still optimization required !!
(29 Dec '12, 15:49)

instead of maintaining two heaps it can also be done using Treaps ( http://en.wikipedia.org/wiki/Treap ) answered 12 Jul '12, 00:30

i am not happy with codechef. When i tried with cin and cout i got TLE and when i tried with printf() and scanf() i got AC. I think Codechef should know that its a algorithmic contest not a HumptyDumpty Language contest... answered 12 Jul '12, 09:21
It's written in FAQ. Also there is practice problem for this... It can be worse  for example when you cannot use HashMap/HashSet or sorting in Java at CodeForces...
(12 Jul '12, 14:43)

getting wrong ans plz check my code... http://www.codechef.com/viewsolution/1956023 answered 22 Mar '13, 04:45

I have submitted it using map and after storing iterating from end still getting tle .... ? answered 08 Dec '14, 05:52

An easy way to solve the problem is to store the first position of box(n/3), say var and see the shifts of this element. Only two cases are held. One case is if n divisible by 3 and var greater than new value inserted, we shift one behind. Its symmetric case is if n not divisible by 3 and var less than or equal to new value inserted, we shift one ahead. Link to Solution : https://www.codechef.com/viewsolution/15162429 answered 29 Aug '17, 21:39

I trid it this like this but it gave TLE in my submission Check my solution https://www.codechef.com/viewsolution/17097907 Help me to rectify my mistake answered 21 Jan '18, 01:59

Alternate approach There is a simpler solution. We use 2 multisets. One stores the top 1/3 elements, other stores the bottom 2/3 elements. Here is a link to a well commented solution of this problem. answered 24 Dec '18, 14:24

JAVA people, whoever is struggling to get rid of TLE for this problem, use BufferedWriter and BufferedReader that will reduce time a lot answered 13 Feb, 21:09

The official editorial is not helpful! Had much trouble in understanding! Nice solution at : https://github.com/executable16/CodeChef/blob/master/RP.cpp Mail me if any doubts : atulmalakar15@gmail.com answered 17 Feb, 14:31
